// Learn cc.Class:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/class.html
// Learn Attribute:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/life-cycle-callbacks.html
var AdManager = {
    // 用于判断SDK是否初始化
    initTag: false,
    // 插屏广告的单例
    adInsert: null,

    maxScore: 0,
    gameRound: 1,
    palyAdTag: true,

    // 初始化HightFiveSDK
    initAdSdk: function() {
        if (this.initTag) {
            return;
        }

        // console.log('初始化HightFive SDK');
        //
        HighFive.onClose(function () {
            this.quit();
        }.bind(this));

        HighFive.initializeAsync()
            .then(HighFive.startGameAsync)
            .then(function () {
                this.initTag = true;
                this.loadAdInsert();
            }.bind(this))
            .catch(function (erro) {
                console.log("初时候SDK erro " + erro.message);
            }.bind(this));
     },

    quit: function () {
        // console.log('退出游戏');
        HighFive.player.setStatsAsync({
            high_score: this.maxScore,
            challenging_levels: 0,
            reward_offline: 0,
            round_num: this.gameRound,

        }).then(HighFive.quit)

    },

    loadAdInsert: function () {
        // console.log('加载插屏广告');
        var self = this;
        HighFive.getInterstitialAdAsync()
            .then(function (ad) {
                // console.log('加载插屏广告');
                self.adInsert = ad;
                ad.loadAsync();
            })
            .catch(function (erro) {
                // console.log('加载插屏广告出错 Erro :' + erro);
            });
    },
    
    playAdInsert: function (cb) {
        var self = this;
        var tag = false;
        if (this.getAdInsertState() && this.palyAdTag) {
            this.palyAdTag = false;
            setTimeout(function () {
                this.palyAdTag = true;
            }.bind(this), 20000);


            tag = true;
            // console.log('播放插屏广告');
            self.adInsert.showAsync()
                .then(function () {
                    self.adInsert.loadAsync();
                    HighFive.adShowChanceArrived(true,HighFive.AdType.interstitial);
                    if (cb) {
                        cb();
                    }


                })
        }else {
            HighFive.adShowChanceArrived(false,HighFive.AdType.interstitial);
            if (cb) {
                cb();
            }

        }
    },

    getAdInsertState: function () {
        var self = this;
        if (self.adInsert && self.adInsert.state === 'loaded') {
            return true;
        } else if (self.adInsert === null) {
            // console.log('插屏广告不存在');
            self.loadAdInsert();
            return false;
        } else {
            // console.log('插屏广告未准备好');
            self.adInsert.loadAsync();
            return false;
        }


    },

    setMaxScore: function (score) {
        if (score > this.maxScore) {
            this.maxScore = score;
        }
    },

    setGameRound: function () {
        this.gameRound++;
    },

    LOG: function (value) {
        // document.write(value);
    },

};